(** set of optimizers for the IMBC. *)

(*
    il4c  --  Compiler for the IL4 Lisp-ahtava langauge
    Copyright (C) 2007 Jere Sanisalo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)

(** Optimizes some common opcode parameters to their fixed equivelant (if called often enough). *)
val optimize_common_opcode_params : Imbc.imbc -> Imbc.imbc

(** Sorts the constants to rising order. *)
val sort_constants : Imbc.imbc -> Imbc.imbc

(** Sorts the opcodes to lowering order (by use). *)
val sort_opcodes : Imbc.imbc -> Imbc.imbc
